/////////////////////////////////////////////////////////////////////////////
// ModelessSamplePlugIn.h

#pragma once

#include "ModelessSampleDialog.h"

/////////////////////////////////////////////////////////////////////////////
// CModelessSamplePlugIn

class CModelessSamplePlugIn : public CRhinoUtilityPlugIn
{
public:
  CModelessSamplePlugIn();
  ~CModelessSamplePlugIn();

  // Required overrides
  const wchar_t* PlugInName() const;
  const wchar_t* PlugInVersion() const;
  GUID PlugInID() const;
  BOOL OnLoadPlugIn();
  void OnSaveAllSettings();
  void OnUnloadPlugIn();

  // Online help overrides
  BOOL AddToPlugInHelpMenu() const;
  BOOL OnDisplayPlugInHelp( HWND hWnd ) const;

  // Modeless dialog helpers
  bool IsDlgCreated();
  bool IsDlgVisible();
  bool SetDlgVisible();
  bool SetDlgHidden();
  bool DisplayDlg();
  void DestroyDlg();
  void ZeroDlg();
  void SetDlgPointValue( int item, const ON_3dPoint& pt );

private:
  ON_wString m_plugin_version;
  CModelessSampleDialog* m_dialog;
};

CModelessSamplePlugIn& ModelessSamplePlugIn();
